#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shellapi.h>
#include <winsock2.h>
#include <string.h>
#include <stdio.h>
#include <direct.h>
#include <fcntl.h>
#include <io.h>
#include "dialog.h"
#include "msgbox.h"
#include "font_select_control.h"
#include "buttonex.h"
#include "stringx.h"
#include "external.h"
#include "dib.h"
#include "coolmenu.h"
#include "splash.h"
#include "common.h"
#include "iprres.h"

extern WNDPROC		pCloseBtnProc,pOkBtnProc,pFontBtnProc,pComboBtnProc;

extern HINSTANCE hInst;
extern HWND hwndMain;
extern HWND  hWndStatusbar;
extern HWND hwndMDIClient;

extern char callback[MAX_PATH];
extern char *szYes;
extern char *szNo;

int ifiperror = 0;

extern HCURSOR hHand,hArrow,hNo;
extern HWND hwndFont,hwndPageSetup,hwndCombo;
extern HMENU hMainMenu, hMainSub;

static LPBITMAPINFO lpBitmap;
static LPTSTR       lpBits;
static RECT         rd;
HANDLE              hRes;
HANDLE              hModule;
GETRES              pGetRes;
long                lSysRes;
char                szTemp[128];
char                szText[128];
LPCTSTR             subkey;
HKEY			    hKey;
DWORD		        dwBytes;
DWORD		        dwType;
MEMORYSTATUS        mst;
char TBT[MAX_PATH]="";

int ovrok = 0;
int timerset = 0;

char *fill;
int pagesetup;
HMENU hMenu,hSubMenu;
HWND hwndEdit;
HGLOBAL MDI[128];
static int cUntitled = 0;
int n = 0;
int i = 0;
int t = 0;

HWND MDICmdFileNew(char *title, char *class, char *l)
{
	HWND  hwndChild;
	char  rgch[150];
	MDICREATESTRUCT mcs;

	fill = l;

	if (class == NULL){
		class= "MdiClass";
	}

	if (title == NULL)
		wsprintf(rgch,"Untitled%d", cUntitled++);
	else {
		strncpy(rgch,title,149);
		rgch[149] = 0;
	}

        mcs.szClass = class;
        mcs.szTitle = rgch;             // window title
        mcs.hOwner  = hInst;            // owner
        mcs.x       = CW_USEDEFAULT;    // x position
        mcs.y       = CW_USEDEFAULT;    // y position
        mcs.cx      = CW_USEDEFAULT;    // width
        mcs.cy      = CW_USEDEFAULT;    // height
        mcs.style   = 0;                // window style
        mcs.lParam  = 0;                // lparam

        hwndChild = (HWND) SendMessage(hwndMDIClient,
                                       WM_MDICREATE,
                                       0,
                                       (LPARAM)(LPMDICREATESTRUCT) &mcs);

	if (hwndChild != NULL)
		ShowWindow(hwndChild, SW_SHOW);

	SendMessage(hwndMDIClient,WM_MDITILE,0,0);
	return hwndChild;
}

void InitMdi(void)
{
}

void AddToCloser(void)
{
	n++;
	t = n;
	t++;
}

int AskCloseQuestion()
{
	int ireturn = MessageBox(hwndMain," Are you sure that you want to close all the windows?"," Close All",MB_YESNO|MB_ICONINFORMATION);
	return ireturn;
}

void CreateMDIChildWindow(char *Title, char *Class, char *PassOn)
{
	MDI[n] = MDICmdFileNew(Title,Class,PassOn);
	AddToCloser();
}

void CloseAllMDIwindows(void)
{
	for (i=0 ; i <t ; i++) {
		SendMessage(MDI[i],WM_CLOSE,0,0);
	}
	cUntitled = 0;
	n = 0;
	t = 0;
}

void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags)
{
    SendMessage(hWndStatusbar,
                SB_SETTEXT,
                partNumber | displayFlags,
                (LPARAM)lpszStatusString);
}

void InitializeStatusBar(HWND hwndParent,int nrOfParts)
{
    const int cSpaceInBetween = 8;
    int   ptArray[40];
    RECT  rect;
    HDC   hDC;

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right/2;
    ptArray[nrOfParts-2] = rect.right;
    ptArray[nrOfParts-3] = rect.right/3;

    ReleaseDC(hwndParent, hDC);
    SendMessage(hWndStatusbar,
                SB_SETPARTS,
                nrOfParts,
                (LPARAM)(LPINT)ptArray);

    UpdateStatusBar("Welcome!", 0, 0);
    UpdateStatusBar("Jacks Mini Network", 1, 0);
}

HWND CreateEditcontrol(HWND hwnd)
{
	hwndEdit = CreateWindow ("edit", NULL, WS_CHILD | WS_HSCROLL | WS_MAXIMIZE |
		WS_VISIBLE | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_READONLY |
		ES_MULTILINE, 0, 0, 0, 0, hwnd, (HMENU)ID_EDIT, hInst,NULL);
    	SetWindowLong (hwnd, GWL_HWNDEDIT, (LONG)hwndEdit);
	SetWindowLong (hwnd, GWL_EDITCHANGED, 0);
	SetFocus (hwndEdit);
	return hwndEdit;
}

int ResizeEditControl(HWND hwnd, LPARAM lParam, HWND hEdit)
{
	hwndEdit = (HWND)GetWindowLong (hwnd, GWL_HWNDEDIT);
	if(!MoveWindow (hwndEdit, 0, 0, LOWORD(lParam),HIWORD(lParam), TRUE))
	{
		if(!MoveWindow (hEdit, 0, 0, LOWORD(lParam),HIWORD(lParam), TRUE))
		{
			return 0;
		}
	}
	return 1;
}

int HandleEditCommands(HWND hwnd, LPARAM lParam, WPARAM wParam)
{
	hwndEdit = (HWND)GetWindowLong (hwnd, GWL_HWNDEDIT);
	if(lParam && LOWORD (wParam) == ID_EDIT)
	{
            	switch (HIWORD(wParam))
                {
	               	case EN_UPDATE:
					case EN_CHANGE:
						SetWindowLong (hwnd, GWL_EDITCHANGED, 1);
						return 0;
		}
	}
	return 1;
}

void FocusEditcontol(HWND hwnd)
{
	SetFocus((HWND)GetWindowLong (hwnd, GWL_HWNDEDIT));
}

HWND CreateButton(int x,int y,int w,int h,char *title,HWND hParent,int ID)
{
	return CreateWindow("BUTTON",title,WS_CHILD|WS_VISIBLE,x,y,w,h,hParent,(HMENU)ID,NULL,NULL);
}

HWND CreateText(int x,int y,int w,int h,char *title,HWND hParent,int ID)
{
	return CreateWindow("STATIC",title,WS_CHILD|WS_VISIBLE,x,y,w,h,hParent,(HMENU)ID,NULL,NULL);
}

HWND CreateWinIcon(int x,int y,int w,int h,HWND hParent,int ID)
{
	return CreateWindow("static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_ICON,x,y,w,h,hParent,(HMENU)ID,hInst,NULL);
}

HWND CreateEditWnd(int x,int y,int w,int h,HWND hParent,int ID)
{
	return CreateWindowEx(WS_EX_CLIENTEDGE,"edit",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|ES_MULTILINE|ES_READONLY|ES_WANTRETURN|WS_VSCROLL|ES_AUTOHSCROLL,x,y,w,h,hParent,(HMENU)ID,hInst,NULL);
}

HWND CreateInputWnd(int x,int y,int w,int h,HWND hParent,int ID)
{
	return CreateWindowEx(WS_EX_CLIENTEDGE,"edit",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|ES_WANTRETURN,x,y,w,h,hParent,(HMENU)ID,hInst,NULL);
}

int SetIcon(HWND hParent,int ID,int RESID)
{
	return SendMessage(GetDlgItem(hParent,ID),STM_SETIMAGE,IMAGE_ICON,(long)LoadIcon(hInst,MAKEINTRESOURCE(RESID)));
}

int SetFont(HWND hParent,int ID,int fontID)
{
	HFONT f_smalltiny=CreateFont(6,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"MS Sans Serif");
	HFONT f_smallbold=CreateFont(6,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"MS Sans Serif");
	HFONT f_smallbig=CreateFont(30,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"MS Sans Serif");

	if(fontID==1)
		SendMessage(GetDlgItem(hParent,ID),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));
	else if(fontID==4)
		SendMessage(GetDlgItem(hParent,ID),WM_SETFONT,(WPARAM)f_smallbig,MAKELPARAM(TRUE,0));
	else
		SendMessage(GetDlgItem(hParent,ID),WM_SETFONT,(WPARAM)f_smallbold,MAKELPARAM(TRUE,0));
	return 1;
}

int SetTxt(HWND hParent,int ID,char *text)
{
	SetWindowText(GetDlgItem(hParent,ID),text);
	return 1;
}

BOOL MagnetWindow(LPARAM *lParam)
{
	RECT *pRect = (LPRECT) *lParam;
	static RECT rcOld = { 0, 0, 0, 0 };
	RECT rcDesktop;
	INT	 iPower = 20;
	SIZE szSize;

	if(FALSE == SystemParametersInfo(SPI_GETWORKAREA, 0, &rcDesktop, 0))
		return FALSE;

	szSize.cx = pRect->right -  pRect->left;
	szSize.cy = pRect->bottom - pRect->top;


	if(pRect->top < iPower && rcOld.top > pRect->top)
	{
		pRect->top = 0;
		pRect->bottom = szSize.cy;
	}
	else
	if(pRect->bottom > (rcDesktop.bottom - iPower) &&
	   rcOld.bottom  < pRect->bottom)
	{
		pRect->bottom = rcDesktop.bottom;
		pRect->top = rcDesktop.bottom - szSize.cy;
	}

	if(pRect->left < iPower && rcOld.left > pRect->left)
	{
		pRect->left = 0;
		pRect->right = szSize.cx;
	}
	else
	if(pRect->right > (rcDesktop.right - iPower) &&
		rcOld.right < pRect-> right)
	{
		pRect->right = rcDesktop.right;
		pRect->left =  rcDesktop.right - szSize.cx;
	}

	rcOld.top = pRect -> top;
	rcOld.bottom = pRect -> bottom;
	rcOld.left = pRect -> left;
	rcOld.right = pRect -> right;

	return FALSE;
}

void EnableMainMenu(int ID, int en)
{
	HMENU WndMenu = GetMenu(hwndMain);

	if(en==1){
		EnableMenuItem(hSubMenu, ID, MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(WndMenu, ID, MF_BYCOMMAND | MF_ENABLED);
	}else{
		EnableMenuItem(hSubMenu, ID, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(WndMenu, ID, MF_BYCOMMAND | MF_GRAYED);
	}
}

extern int p;
extern RECT Wrc;
void PageSetupWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	switch(id) {
		case IDOK:
			pagesetup = 0;
		    UpdateStatusBar("Welcome!", 0, 0);
			ShowWindow(hwnd,SW_HIDE);
			EnableMainMenu(IDM_PRINTSU,1);
			GetWindowRect(hwndMain, &Wrc);
			for (p=0 ; p <145 ; p++) {
				Sleep(1);
				MoveWindow(hwndMain,Wrc.left,Wrc.top+p+p+p+p,500, 500, TRUE);
			}
			break;
	}
}

void PrintSetup(void)
{
	pagesetup = 1;
	ShowWindow(hwndPageSetup,SW_SHOW);
	EnableMainMenu(IDM_PRINTSU,0);
    UpdateStatusBar("Options?", 0, 0);
}

TCHAR szFont[512];
LRESULT CALLBACK PageSetupWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	WORD wCtrlID = LOWORD(wParam);
	WORD wCmdID  = HIWORD(wParam);
	switch (msg) {
	case WM_CREATE:
			return 0;

	case WM_TIMER:
		timerset = 0;
		KillTimer(hwnd,12);
		ovrok = 0;
		return 0;

	case WM_MOVING:
		return MagnetWindow(&lParam);

	case WM_COMMAND:
			switch (wCmdID)
			{
				case CBN_SELENDOK:
				{
					GetWindowText((HWND) lParam, szFont, 512);
					switch (wCtrlID)
					{
						case 720:
						{
							if(szFont){
								MessageBox(hwnd, szFont, TEXT("Selected Font"), 0);
							}else {
								return 0;
							}
							break;
						}
						case 721:
						{
							if((HWND) lParam){
								MessageBox(hwnd, "Invalid Printer!", TEXT("Printer"), 0);
								SendMessage(hwndCombo, CB_SELECTSTRING, 0, (LPARAM) TEXT("-----------------------------------------------------"));
							}else{
								return (lParam);
							}
							break;
						}
					}
				}
			}
		HANDLE_WM_COMMAND(hwnd,wParam,lParam,PageSetupWndProc_OnCommand);
		break;
	case WM_CLOSE:
		break;
	case WM_DESTROY:
		SetWindowLong(GetDlgItem(hwnd, IDOK), GWL_WNDPROC, (DWORD)pOkBtnProc) ;
		SetWindowLong(hwndFont, GWL_WNDPROC, (DWORD)pFontBtnProc) ;
		SetWindowLong(hwndCombo, GWL_WNDPROC, (DWORD)pComboBtnProc) ;
		break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}

LRESULT CALLBACK CloseCtrlWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg){
		case WM_SETCURSOR:
			SetCursor(hHand);
			return 0;
		default:
			return CallWindowProc(pCloseBtnProc, hWnd, msg, wParam, lParam) ;
	}
}

LRESULT CALLBACK OkCtrlWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg){
		case WM_SETCURSOR:
			ovrok = 1;
			SetCursor(hHand);
			return 0;
		default:
			if(timerset==0){
			if(pagesetup==1){
				if(ovrok==0){
				    UpdateStatusBar("Options?", 0, 0);
				}else{
				    UpdateStatusBar("Quit Options?", 0, 0);
					SetTimer(hwndPageSetup,12,1000,NULL);
					timerset = 1;
				}
			}}
			return CallWindowProc(pOkBtnProc, hWnd, msg, wParam, lParam) ;
	}
}

LRESULT CALLBACK FontCtrlWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg){
		case WM_SETCURSOR:
			SetCursor(hArrow);
			return 0;
		default:
			return CallWindowProc(pFontBtnProc, hWnd, msg, wParam, lParam) ;
	}
}

LRESULT CALLBACK ComboCtrlWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg){
		case WM_SETCURSOR:
			SetCursor(hNo);
			return 0;
		default:
			return CallWindowProc(pComboBtnProc, hWnd, msg, wParam, lParam) ;
	}
}

int CreateAboutBox(HWND hParent)
{
	CreateEditWnd(14,108,308,134,hParent,ID_ABOUTBOX_07);
	SetFont(hParent,ID_ABOUTBOX_07,-1);
	SetTxt(hParent,ID_ABOUTBOX_07,"");
	CreateButton(272,15,45,78,"Ok",hParent,IDOK);
	SetFont(hParent,IDOK,1);
	CreateText(90,15,120,18,"IP Resolve",hParent,ID_ABOUTBOX_02);
	SetFont(hParent,ID_ABOUTBOX_02,1);
	CreateText(75,30,90,14,"Version :",hParent,ID_ABOUTBOX_03);
	SetFont(hParent,ID_ABOUTBOX_03,1);
	CreateText(150,30,90,14,"2",hParent,ID_ABOUTBOX_03*10);
	SetFont(hParent,ID_ABOUTBOX_03*10,1);
	CreateText(75,45,90,14,"Memory :",hParent,ID_ABOUTBOX_04);
	SetFont(hParent,ID_ABOUTBOX_04,1);
	CreateText(150,45,90,14,"0 MByte",hParent,ID_ABOUTBOX_04*10);
	SetFont(hParent,ID_ABOUTBOX_04*10,-1);
	CreateText(75,60,90,14,"Copyright :",hParent,ID_ABOUTBOX_05);
	SetFont(hParent,ID_ABOUTBOX_05,1);
	CreateText(150,60,110,14,"Jacks Mini Network",hParent,ID_ABOUTBOX_05*10);
	SetFont(hParent,ID_ABOUTBOX_05*10,1);
	CreateText(65,75,205,14,"http://downloadsatjacksmininet.tripod.com",hParent,ID_ABOUTBOX_06);
	SetFont(hParent,ID_ABOUTBOX_06,1);
	CreateWinIcon(15,12,18,20,hParent,72);
	SetIcon(hParent,72,IDAPPLICON);
	CreateWinIcon(15,48,18,20,hParent,73);
	SetIcon(hParent,73,730);
	return 1;
}

int CentreWnd(HWND hDlg)
{
	RECT rc ;
	GetWindowRect(hDlg,&rc) ;
	SetWindowPos(hDlg,NULL,
		((GetSystemMetrics(SM_CXSCREEN) -(rc.right - rc.left))/2),
		((GetSystemMetrics(SM_CYSCREEN) -(rc.bottom - rc.top))/2),
		0,0,SWP_NOSIZE || SWP_NOACTIVATE) ;
	return 1;
}

int InitializeAboutScreen(HWND hDlg)
{
	SetWndIcon(hDlg);
	CentreWnd(hDlg);
	return 1;
}

int SetWndIcon(HWND hDlg)
{
	HICON hIcon ;
	hIcon = LoadIcon(GetModuleHandle(NULL),MAKEINTRESOURCE(728)) ;
	SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,  (LPARAM)hIcon) ;
	SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_SMALL,(LPARAM)hIcon) ;
	return 1;
}

int CheckMemory(HWND hDlg)
{
		if (IS_NT)
			subkey = "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion";
		else
			subkey = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion";

		RegOpenKeyEx(HKEY_LOCAL_MASHINE, subkey, 0, KEY_ALL_ACCESS, &hKey);
		dwType  = REG_SZ;
		dwBytes = 128;
		RegQueryValueEx(hKey, "RegisteredOwner", 0,
						&dwType, szText, &dwBytes);
		strcpy(TBT,"");
		strcat(TBT,"Hello ");
		strcat(TBT,szText);
		RegQueryValueEx(hKey, "RegisteredOrganization", NULL,
	   					&dwType, szText, &dwBytes);
		strcat(TBT,", Of company: ");
		strcat(TBT,szText);
		strcat(TBT,".");
		strcat(TBT," Origional Author of the IP and DNS functions : Wee Jin Goh");
		RegCloseKey(hKey);

		memset(&mst, 0, sizeof(mst));
		mst.dwLength = sizeof(mst);
		GlobalMemoryStatus(&mst);

		wsprintf(szText, "%i", (mst.dwTotalPhys / 1024 / 1000));
		lstrcat(szText, " MByte");
		SetDlgItemText(hDlg, ID_ABOUTBOX_04*10, szText);

		if (IS_WIN95)
		{
			hModule = LoadLibrary("RSRC32.dll");
			if (hModule != NULL)
			{
				pGetRes = (GETRES) GetProcAddress(hModule,
										   "_MyGetFreeSystemResources32@4");
				if (pGetRes)
					lSysRes = (*pGetRes)(GFSR_SYSTEMRESOURCES);

				wsprintf(szText, "%d", lSysRes);
				lstrcat(szText, " % frei");
				FreeLibrary(hModule);
			}
		}
		hRes = LoadResource(hInst,
					FindResource(hInst, "#200", RT_BITMAP));
		lpBitmap = (LPBITMAPINFO) LockResource(hRes);
		lpBits   = (LPTSTR) lpBitmap;
		lpBits   += lpBitmap->bmiHeader.biSize +
					(256 * sizeof(RGBQUAD));
		return 1;
}

void CreateAllMenus(void)
{
	hMainMenu = CreateMenu();
	HMENU hMainSub = CreatePopupMenu();
	AppendMenu(hMainMenu, MF_STRING | MF_POPUP, (UINT)hMainSub, "&File");
	AppendMenu(hMainSub, MF_STRING, IDM_NEW, "&Open Info Window");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_OPEN, "&Search IP or DNS");
	AppendMenu(hMainSub, MF_STRING, IDM_SAVE, "&Save");
	AppendMenu(hMainSub, MF_STRING, IDM_SAVEAS, "Save &As...");
	AppendMenu(hMainSub, MF_STRING, IDM_CLOSE, "&Close Info Window");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_PRINT, "&Print");
	AppendMenu(hMainSub, MF_STRING, IDM_PRINTSU, "P&rint Setup...");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_EXIT, "E&xit");
	hMainSub = CreatePopupMenu();
	AppendMenu(hMainMenu, MF_STRING | MF_POPUP, (UINT)hMainSub, "&Edit");
	AppendMenu(hMainSub, MF_STRING, IDM_EDITUNDO, "&Undo\tAlt+BkSp");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_EDITCUT, "Cu&t\tShift+Del");
	AppendMenu(hMainSub, MF_STRING, IDM_EDITCOPY, "&Copy\tCtrl+Ins");
	AppendMenu(hMainSub, MF_STRING, IDM_EDITPASTE, "&Paste\tShift+Ins");
	AppendMenu(hMainSub, MF_STRING, IDM_EDITCLEAR, "&Delete\tDel");
	hMainSub = CreatePopupMenu();
	AppendMenu(hMainMenu, MF_STRING | MF_POPUP, (UINT)hMainSub, "&Window");
	AppendMenu(hMainSub, MF_STRING, IDM_WINDOWTILE, "&Tile");
	AppendMenu(hMainSub, MF_STRING, IDM_WINDOWCASCADE, "&Cascade");
	AppendMenu(hMainSub, MF_STRING, IDM_WINDOWICONS, "Arrange &Icons");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_WINDOWCLOSEALL, "Close &All");
	hMainSub = CreatePopupMenu();
	AppendMenu(hMainMenu, MF_STRING | MF_POPUP, (UINT)hMainSub, "&Help");
	AppendMenu(hMainSub, MF_STRING, IDM_HELP, "&Help");
	AppendMenu(hMainSub, MF_SEPARATOR, 0, "");
	AppendMenu(hMainSub, MF_STRING, IDM_ABOUT, "&About");
	SetMenu(hwndMain, hMainMenu);
	EnableMainMenu(IDM_OPEN,1);
	EnableMainMenu(IDM_SAVE,0);
	EnableMainMenu(IDM_SAVEAS,0);
	EnableMainMenu(IDM_CLOSE,0);
	EnableMainMenu(IDM_PRINT,0);
	EnableMainMenu(IDM_EDITUNDO,0);
	EnableMainMenu(IDM_EDITCUT,0);
	EnableMainMenu(IDM_EDITCOPY,0);
	EnableMainMenu(IDM_EDITPASTE,0);
	EnableMainMenu(IDM_EDITCLEAR,0);
	EnableMainMenu(IDM_HELP,0);
	HMENU hsub = GetSubMenu(hMainMenu, 0);
	CoolMenu_Create(hsub, "File");
	hsub = GetSubMenu(hMainMenu, 1);
	CoolMenu_Create(hsub, "Edit");
	hsub = GetSubMenu(hMainMenu, 2);
	CoolMenu_Create(hsub, "Window");
	hsub = GetSubMenu(hMainMenu, 3);
	CoolMenu_Create(hsub, "Help");
}

/*********************
*Handle the user clicking IDC_GET_IP
**********************/
HWND DialogFunc_OnGetIP(HWND hDlg, char *ipdata)
{
	struct hostent *h;
	char dns[MAX_PATH];
	char ip[MAX_PATH];

	strcpy(dns,ipdata);
	h = gethostbyname(dns);
	if(h == NULL) {
		ifiperror = 1;
	    MsgBox(hInst, hDlg, " DNS does not exist", "Error finding IP");
		return;
	}

	sprintf(ip, "%s", inet_ntoa(*(struct in_addr *)h->h_addr));
	strcpy(callback,"");
	strcat(callback,"The IP addres is : ");
	strcat(callback,ip);
	return ip;

}


/*********************************************
*Handle the user clicking IDC_GET_DNS
*********************************************/
HWND DialogFunc_OnGetDNS(HWND hDlg, char *ipdata)
{
	struct hostent *h;
	char dns[MAX_PATH];
	char ip[MAX_PATH];

	strcpy(ip,ipdata);
	struct in_addr addr;
	addr.s_addr = inet_addr(ip);
	h = gethostbyaddr((const char *)&addr, sizeof(struct in_addr), AF_INET);
	if(h == NULL) {
		ifiperror = 1;
	    MsgBox(hInst, hDlg, " Host not found", "Error finding IP...");
		return;
	}

	sprintf(dns, "%s", h->h_name);
	strcpy(callback,"");
	strcat(callback,"The DNS name is : ");
	strcat(callback,dns);
	return ip;

}

void SearchIP(void)
{
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0), &wsaData);
    InputBox(hInst, hwndMain, " Submit data", "Input the DNS name or IP addres to search");
	szYes = "IP";
	szNo = "DNS";
	if(CreateOwnerDialog(hwndMain, "Which are you trying to find?")==IDCANCEL){
		DialogFunc_OnGetDNS(hwndMain, callback);
	}else{
		DialogFunc_OnGetIP(hwndMain, callback);
	}

	if(ifiperror==0){
		CreateMDIChildWindow("Example", NULL, callback);
	}

	ifiperror = 0;
	szYes = "Yes";
	szNo = "No";
}

