#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shellapi.h>
#include <winsock2.h>
#include <string.h>
#include <stdio.h>
#include <direct.h>
#include <fcntl.h>
#include <io.h>
#include "dialog.h"
#include "msgbox.h"
#include "font_select_control.h"
#include "buttonex.h"
#include "stringx.h"
#include "external.h"
#include "dib.h"
#include "coolmenu.h"
#include "splash.h"
#include "common.h"
#include "iprres.h"

extern HGLOBAL MDI[128];
extern static int cUntitled;
extern int n,i,t;

extern char *fill;
HINSTANCE hInst;
HWND hwndMain;
HWND hwndInfoWnd1;
HWND  hWndStatusbar;
HWND hwndMDIClient;
WSADATA *WsaData;

extern char callback[MAX_PATH];
extern char *szYes;
extern char *szNo;

extern int ifiperror;

WNDPROC		pCloseBtnProc = NULL;
WNDPROC		pOkBtnProc = NULL;
WNDPROC		pFontBtnProc = NULL;
WNDPROC		pComboBtnProc = NULL;

HWND hwndFont,hwndPageSetup,hwndCombo;
HCURSOR hHand,hArrow,hNo;
HMENU hMainMenu, hMainSub;

LRESULT CALLBACK IPWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK MdiWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

LRESULT MsgMenuSelect(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    static char szBuffer[256];
    UINT   nStringID = 0;
    UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
    UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
    HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

    szBuffer[0] = 0;                            // First reset the buffer
    if (fuFlags == 0xffff && hMenu == NULL)     // Menu has been closed
        nStringID = 0;

    else if (fuFlags & MFT_SEPARATOR)           // Ignore separators
        nStringID = 0;

    else if (fuFlags & MF_POPUP)                // Popup menu
    {
        if (fuFlags & MF_SYSMENU)               // System menu
            nStringID = IDS_SYSMENU;
        else
            // Get string ID for popup menu from idPopup array.
            nStringID = 0;
    }  // for MF_POPUP
    else                                        // Must be a command item
        nStringID = uCmd;                       // String ID == Command ID

    if (0 != nStringID){
        LoadString(hInst, nStringID, szBuffer, sizeof(szBuffer));
	    UpdateStatusBar(szBuffer, 1, 0);
	}else{
	    UpdateStatusBar("Jacks Mini Network", 1, 0);
	}
    return 0;
}

static BOOL CreateSBar(HWND hwndParent,char *initialText,int nrOfParts)
{
    hWndStatusbar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,
                                       initialText,
                                       hwndParent,
                                       IDM_STATUSBAR);
    if(hWndStatusbar)
    {
        InitializeStatusBar(hwndParent,nrOfParts);
        return TRUE;
    }

    return FALSE;
}

static BOOL InitApplication(void)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)IPWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszClassName = "MainClass";
	wc.lpszMenuName = MAKEINTRESOURCE(IDMAINMENU);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDAPPLICON));
	if (!RegisterClass(&wc))
		return 0;

	wc.style         = 0;
	wc.lpfnWndProc   = (WNDPROC)MdiWndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 20;
	wc.hInstance     = hInst;
	wc.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(IDI_CHILDICON));
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = "MdiClass";
	if (!RegisterClass((LPWNDCLASS)&wc))
		return FALSE;

	WNDCLASS wc1;
	memset(&wc1,0,sizeof(WNDCLASS));
	wc1.style=CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS|CS_BYTEALIGNCLIENT |CS_BYTEALIGNWINDOW;
	wc1.lpfnWndProc=(WNDPROC)PageSetupWndProc;
	wc1.hInstance=hInst;
	wc1.hbrBackground=(HBRUSH)(COLOR_APPWORKSPACE+1);
	wc1.lpszClassName="FontMainClass";
	wc1.lpszMenuName=NULL;
	wc1.hCursor = LoadCursor(0,IDC_ARROW);
	wc1.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(728));
	if (!RegisterClass(&wc1))
		return 0;

	return 1;
}

HWND CreatePageSetupClassWnd(void)
{
	return CreateWindowEx(WS_EX_TOPMOST|WS_EX_STATICEDGE,
		"FontMainClass","Page Setup",
		WS_POPUP|WS_BORDER,
		425,36,241,250,
		NULL,
		NULL,
		hInst,
		NULL);
}

HWND CreateMainClassWnd(void)
{
	return CreateWindowEx(WS_EX_TOPMOST|WS_EX_STATICEDGE,
		"MainClass","IP Finder",
		WS_POPUP|WS_BORDER,
//		WS_MINIMIZEBOX|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_CAPTION|WS_BORDER|WS_SYSMENU,
		100,100,500,500, //CW_USEDDEFAULT
		NULL,
		NULL,
		hInst,
		NULL);
}

extern char TBT[MAX_PATH];
BOOL _stdcall AboutDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
		case WM_CREATE:
		case WM_INITDIALOG:
			InitializeAboutScreen(hwnd);
			CreateAboutBox(hwnd);
			CheckMemory(hwnd);
			SetTxt(hwnd,ID_ABOUTBOX_07,TBT);
			pCloseBtnProc = (WNDPROC)SetWindowLong(GetDlgItem(hwnd, IDOK),
								GWL_WNDPROC, (DWORD)CloseCtrlWndProc) ;
			return 1;
		case WM_MOVING:
			return MagnetWindow(&lParam);
		case WM_CLOSE:
			return 1;
		case WM_DESTROY:
			SetWindowLong(GetDlgItem(hwnd, IDOK), GWL_WNDPROC, (DWORD)pCloseBtnProc) ;
			return 1;
		case WM_ACTIVATE:
			SendMessage(GetParent(hwnd), WM_NCACTIVATE, TRUE, 0);
			return (FALSE);
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					EndDialog(hwnd,1);
					return 1;
			}
			break;
	}
	return 0;
}

int p;
RECT Wrc;
int ifcloseall;
void IPWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	switch(id) {
		case IDM_ABOUT:
		DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwndMain,AboutDlg);
		break;
		case IDM_PRINTSU:
		GetWindowRect(hwndMain, &Wrc);
		for (p=0 ; p <290 ; p++) {
			Sleep(0.9);
			MoveWindow(hwnd,Wrc.left,Wrc.top-p-p,500, 500, TRUE);
		}
		PrintSetup();
		break;
		case IDM_OPEN:
		SearchIP();
		break;
		case IDM_NEW:
		EnableMainMenu(IDM_NEW,0);
		EnableMainMenu(IDM_CLOSE,1);
		CreateMDIChildWindow(NULL, NULL, "I think this is the new file??");
		SetFont(MDI[n-1],ID_EDIT,1);
		hwndInfoWnd1 = MDI[n-1];
		break;
		case IDM_CLOSE:
		EnableMainMenu(IDM_NEW,1);
		EnableMainMenu(IDM_CLOSE,0);
		PostMessage(hwndInfoWnd1,WM_CLOSE,0,0);
		break;
		case IDM_WINDOWTILE:
		SendMessage(hwndMDIClient,WM_MDITILE,0,0);
		break;
		case IDM_WINDOWCASCADE:
		SendMessage(hwndMDIClient,WM_MDICASCADE,0,0);
		break;
		case IDM_WINDOWICONS:
		SendMessage(hwndMDIClient,WM_MDIICONARRANGE,0,0);
		break;
		case IDM_WINDOWCLOSEALL:
		ifcloseall = CreateOwnerDialog(hwndMain, "Are you sure that you want to close all the MDI windows??");
		switch(ifcloseall) {
			case IDOK:
			case IDYES:
				CloseAllMDIwindows();

			case IDCANCEL:
			case IDNO:
				break;

			default:
				break;
		}
		break;
		case IDM_EXIT:
		PostMessage(hwnd,WM_CLOSE,0,0);
		break;
	}
}

static HWND CreateMdiClient(HWND hwndparent)
{
    CLIENTCREATESTRUCT ccs = {0};
    HWND hwndMDIClient;
    int icount = GetMenuItemCount(GetMenu(hwndparent));

    ccs.hWindowMenu  = GetSubMenu(GetMenu(hwndparent), icount-2);
    ccs.idFirstChild = IDM_WINDOWCHILD;

    hwndMDIClient = CreateWindow("mdiclient",
                                 NULL,
                                 WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL |
                                 WS_HSCROLL,
                                 0, 0, 0, 0,
                                 hwndparent,
                                 (HMENU)0xCAC,
                                 hInst,
                                 (LPVOID)&ccs);

    ShowWindow(hwndMDIClient, SW_SHOW);
    return hwndMDIClient;
}

LRESULT CALLBACK MdiWndProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
	HWND hEdit;

	switch(msg) {
		case WM_CREATE:
			InitMdi();
			hEdit = CreateEditcontrol(hwnd);
			SetWindowText(hEdit,fill);
			SetFont(hwnd,ID_EDIT,4);
			break;
		case WM_MOVE:
		case WM_DESTROY:
		case WM_CLOSE:
			SendMessage(hwndMDIClient,WM_MDITILE,0,0);
			break;
		case WM_SIZE:
			ResizeEditControl(hwnd,lparam,hEdit);
			SendMessage(hwndMDIClient,WM_MDITILE,0,0);
			break;
		case WM_COMMAND:
			HandleEditCommands(hwnd, lparam, wparam);
			break;
		case WM_SETFOCUS:
			FocusEditcontol(hwnd);
			break;
	}
	return DefMDIChildProc(hwnd, msg, wparam, lparam);
}

extern int pagesetup;
LRESULT CALLBACK IPWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch (msg) {
		case WM_CREATE:
			hwndMDIClient = CreateMdiClient(hwnd);
			GetWindowRect(hwnd, &Wrc);
			MoveWindow(hwnd,Wrc.left,Wrc.top, 500, 500, TRUE);
			break;
		case WM_SIZE:
			SendMessage(hWndStatusbar,msg,wParam,lParam);
			InitializeStatusBar(hWndStatusbar,3);
			if (wParam != SIZE_MINIMIZED) {
				RECT rc, rcClient;
				GetClientRect(hwnd, &rcClient);
				GetWindowRect(hWndStatusbar, &rc);
				ScreenToClient(hwnd, (LPPOINT)&rc.left);
				rcClient.bottom = rc.top;
				MoveWindow(hwndMDIClient,rcClient.left,rcClient.top,rcClient.right-rcClient.left, rcClient.bottom-rcClient.top, TRUE);
			}
			SendMessage(hwndMDIClient,WM_MDITILE,0,0);
			return 0;
		case WM_MOVING:
			MoveWindow(hwnd,Wrc.left,Wrc.top,Wrc.right, Wrc.bottom-Wrc.top, TRUE);
			return 0;
		case WM_CONTEXTMENU :
			CoolMenu_PopupContext(hwnd, lParam, 1);
			return 0;
		case WM_MEASUREITEM :
			return CoolMenu_MeasureItem(wParam, lParam);
		case WM_DRAWITEM :
			return CoolMenu_DrawItem(wParam, lParam);
		case WM_MENUSELECT:
			return MsgMenuSelect(hwnd,msg,wParam,lParam);
		case WM_COMMAND:
			HANDLE_WM_COMMAND(hwnd,wParam,lParam,IPWndProc_OnCommand);
			break;
		case WM_CLOSE:
			CloseAllMDIwindows();
			if(pagesetup==0){
				GetWindowRect(hwndMain, &Wrc);
				for (p=0 ; p <300 ; p++) {
					Sleep(1);
					MoveWindow(hwndMain,Wrc.left,Wrc.top-p-p,500, 500, TRUE);
				}
			}else{
				return 0;
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefFrameProc(hwnd,hwndMDIClient,msg,wParam,lParam);
	}
	return DefFrameProc(hwnd,hwndMDIClient,msg,wParam,lParam);
}

WSADATA *InitWS2(void)
{
    int           Error;              // catches return value of WSAStartup
    WORD          VersionRequested;   // passed to WSAStartup
    static WSADATA       WsaData;            // receives data from WSAStartup
    BOOL          ReturnValue = TRUE; // return value flag

    VersionRequested = MAKEWORD(2, 0);
    Error = WSAStartup(VersionRequested, &WsaData);
    if (Error) {
        MessageBox(hwndMain,
                   "Could not find high enough version of WinSock",
                   "Error", MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
        ReturnValue = FALSE;
    } else {
        if (LOBYTE(WsaData.wVersion) != 2) {
            MessageBox(hwndMain,
                       "Could not find the correct version of WinSock",
                       "Error",  MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
            WSACleanup();
            ReturnValue = FALSE;
        }
    }
    if (ReturnValue)
        return &WsaData;
    return(NULL);

}

int rtn;
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	HANDLE hAccelTable;
	HANDLE mutex_handle;
	hHand = LoadCursor(hInstance,MAKEINTRESOURCE(731));
	hNo = LoadCursor(hInstance,MAKEINTRESOURCE(734));
	hArrow = LoadCursor(0,IDC_ARROW);
	mutex_handle=CreateMutex(NULL,TRUE,"IPFinder");
	if (mutex_handle)
	{
	rtn=GetLastError();
	if (rtn!=ERROR_ALREADY_EXISTS){
	hInst = hInstance;
	if (!InitApplication())
		return 0;
	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	if ((hwndMain = CreateMainClassWnd()) == (HWND)0)
		return 0;
	CreateSBar(hwndMain,"Ready",3);
	ShowWindow(hwndMain,SW_HIDE);
	WsaData = InitWS2();
	if (WsaData == NULL)
		return 0;
//	CreateMDIChildWindow("Server-2", NULL, "192.168.1.66");
	CreateMDIChildWindow("Example", NULL, "This example has a frame and moves using the FOR command!");
	CreateMDIChildWindow("Example", NULL, " http://downloadsatjacksmininet.tripod.com");
	SetFont(MDI[n-1],ID_EDIT,1);
	SetFont(MDI[n-2],ID_EDIT,0);
	if ((hwndPageSetup = CreatePageSetupClassWnd()) == (HWND)0)
		return 0;
	PostMessage(hwndMain,WM_SIZE,0,0);
	ShowWindow(hwndPageSetup,SW_HIDE);
	UpdateWindow(hwndMain);
	CreateText(0,0,400,400," ",hwndPageSetup,1100);
	if (!xRegisterFontControl()) return FALSE;

	hwndFont = CreateWindowEx(0, SELECT_FONT_CLASS, TEXT(""), WS_CHILD | WS_VISIBLE,
	                          10, 60, 200, 0,
	                          hwndPageSetup, (HMENU) 720, GetModuleHandle(NULL), NULL);
	SendMessage(hwndFont, FCM_ADD_ALL_FONTS, 0, 0);
	SendDlgItemMessage(hwndFont, FC_COMBO, CB_SELECTSTRING, (WPARAM) -1, (LPARAM) TEXT("Comic Sans MS"));
	ShowWindow(hwndFont,SW_SHOW);

	hwndCombo = CreateWindowEx(0, TEXT("COMBOBOX"), TEXT(""), CBS_DROPDOWNLIST | WS_CHILD | WS_VISIBLE | WS_VSCROLL,
	                           10, 130, 200, 150,
	                           hwndPageSetup, (HMENU) 721, GetModuleHandle(NULL), NULL);
	SendMessage(hwndCombo, CB_ADDSTRING, 0, (LPARAM) TEXT("-----------------------------------------------------"));
	SendMessage(hwndCombo, CB_ADDSTRING, 0, (LPARAM) TEXT("Printing not supported!"));
	SendMessage(hwndCombo, CB_ADDSTRING, 0, (LPARAM) TEXT("None"));
	SendMessage(hwndCombo, CB_SELECTSTRING, 0, (LPARAM) TEXT("-----------------------------------------------------"));
	ShowWindow(hwndCombo,SW_SHOW);

	CreateText(50,5,90,14,"Page Setup",hwndPageSetup,14);
	SetFont(hwndPageSetup,14,-1);
	CreateWinIcon(60,22,18,20,hwndPageSetup,13);
	SetIcon(hwndPageSetup,13,729);
	CreateWinIcon(60,92,18,20,hwndPageSetup,16);
	SetIcon(hwndPageSetup,16,730);
	CreateText(10,30,45,14,"Font:",hwndPageSetup,12);
	SetFont(hwndPageSetup,12,-1);
	CreateText(10,100,45,14,"Printer:",hwndPageSetup,15);
	SetFont(hwndPageSetup,15,-1);
	CreateButton(10,160,200,78,"Save",hwndPageSetup,IDOK);
	SetFont(hwndPageSetup,IDOK,-1);

	pOkBtnProc = (WNDPROC)SetWindowLong(GetDlgItem(hwndPageSetup, IDOK),
						GWL_WNDPROC, (DWORD)OkCtrlWndProc) ;
	pFontBtnProc = (WNDPROC)SetWindowLong(hwndFont,
						GWL_WNDPROC, (DWORD)FontCtrlWndProc) ;
	pComboBtnProc = (WNDPROC)SetWindowLong(hwndCombo,
						GWL_WNDPROC, (DWORD)ComboCtrlWndProc) ;


	CreateAllMenus();
	GetWindowRect(hwndMain, &Wrc);
	for (p=0 ; p <290 ; p++) {
		MoveWindow(hwndMain,Wrc.left,Wrc.top-p-p,500, 500, TRUE);
	}
	ShowWindow(hwndMain,SW_SHOW);
	GetWindowRect(hwndMain, &Wrc);
	for (p=0 ; p <145 ; p++) {
		Sleep(1);
		MoveWindow(hwndMain,Wrc.left,Wrc.top+p+p+p+p,500, 500, TRUE);
	}

//    MsgBox(hInst, hwndMain, " DNS does not exist", "Error finding IP");
//    MsgBox(hInst, hwndMain, " Host not found", "Error finding IP...");
	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateMDISysAccel(hwndMDIClient, &msg))
			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
				TranslateMessage(&msg);  // Translates virtual key codes
				DispatchMessage(&msg);   // Dispatches message to window
			}
	}
	return msg.wParam;
	}}
	if (rtn=ERROR_ALREADY_EXISTS){
		static FARPROC Crash;
		Crash();
	}
	CoolMenu_Cleanup(hwndMain);
	WSACleanup();
	return 0;
}

